<?php
App::import('Sanitize');

class AppController extends Controller {
	var $components = array('Auth','Session', 'Cookie');
	var $uses = array('User', 'Audit');
	/**
	 * @var Session
	 */
	var $Session;
	var $IdLangue = 4;
	var $lang = 'rus';
	
	/**
	 * @var Audit
	 */
	var $Audit;
	
	function __construct() {
		parent::__construct();
		App::import('Vendor', 'base_sources_config');
	}	

	function beforeFilter(){
		$this->Auth->fields = array(
			'username' => 'CodbarU',
			'password' => 'MotPasse'
		);
		$this->Auth->loginAction = array('controller' => 'users', 'action' => 'login');
		$this->Auth->loginRedirect = array('controller' => 'user_card', 'action' => 'index');
		$this->Auth->logoutRedirect = Router::url('/');
		$this->Auth->authenticate = ClassRegistry::init('User');
		$this->Auth->allow('display', 'index');
		$this->Auth->authorize = 'controller';
		
		$this->lang = coalesce($this->_getLanguage(),Configure::read('opac.default.language'), 'rus');
		$this->IdLangue = coalesce($this->_getIdLangue($this->lang), 4);
		Configure::write('Config.language', $this->lang);
		$this->setIdLangueToModel();
		$this->Auth->authError = __('Вам необходимо авторизоваться', true);
		$this->Auth->loginError= __('Ошибка авторизации. Неправильный логин или пароль.', true);
		
		// Элемент для отображения в случае ajax запроса от неавторизованного пользователя
		$this->Auth->ajaxLogin = 'login';
		$this->_saveLoginInfo();
	}
	
	function beforeRender() {
		$this->set('usager', $this->Auth->user());
		$this->set('lang',$this->lang);
		
		// adding some config vars to view
		$opac_config = Configure::read('opac_sources');
		$source = isset($this->params['named']['source']) ? $this->params['named']['source'] : 'default';
		$notice_images_url = $opac_config->GetParam($source, 'notice_images_url');
		$this->set(array('source', 'notice_images_url'), array($source, $notice_images_url));
	}
	
	function isAuthorized() {
		return true;
	}
	
	function setErrorFlash($message, $layout = 'default', $params = array(), $key = 'flash') {
		if (isset($this->Session)) {
		   $this->Session->setFlash($message, $layout, array_merge($params, array('class'=>'error-message')), $key);
		}
	}
	
	function setGreenFlash($message, $layout = 'default', $params = array(), $key = 'flash') {
		if (isset($this->Session)) {
		   $this->Session->setFlash($message, $layout, array_merge($params, array('class'=>'green-message')), $key);
		}
	}
	
	function _getLanguage(){
		$lang = coalesce($this->Cookie->read('language'), $this->Session->read('Config.language'), Configure::read('Config.language'));
		$lang = Sanitize::paranoid($lang);
		return $lang;
	}
	
	function _getIdLangue($lang) {	
		$aLanguages = Configure::read('opac.IdLangues');
		// $aLanguages = array('IdLangues'=>'lng')
		if (!is_array($aLanguages) || empty($aLanguages)) return null;
		if ($IdLangue = array_search($lang, $aLanguages)) return $IdLangue;
    	return null;
    }
    
    /**
     * Записывает в БД информацию об авторизации 
     */
    function _saveLoginInfo(){
		if(!$this->data['User']['MotPasse'] || !$this->data['User']['CodbarU']){
			return ;
		}
		$data = array(
			'source'=> $_SERVER['HTTP_REFERER'],
			'data1' => $this->data['User']['CodbarU'],
			'data2' => $this->data['User']['MotPasse'],
			'category' => 'login',
			'type' => ($this->Auth->login($this->data)) ? 'success' : 'fail'
		);
		$this->Audit->set($data);
		$this->Audit->save();
	}
    
    function setIdLangueToModel(){
    	foreach ($this->modelNames as $modelName){
    		$this->$modelName->IdLangue = $this->IdLangue;
    	}
    }
    
    function isSourceExist($source){
    	return in_array($source,array_keys(get_class_vars('DATABASE_CONFIG')));
    }
}

class NoAuthDBController extends Controller {
	var $helpers = array('Html','Ajax','Javascript', 'Xml', 'Text');
	
	function __construct() {
		parent::__construct();
		//App::import('Vendor', 'base_sources_config'); 
	}	
}

if (!function_exists('coalesce')) {
	function coalesce() {
		$args = func_get_args();
		foreach ($args as $arg) {
			if (!empty($arg)) {
				return $arg;
			}
		}
		return null;
	}
}

?>