<?php
class AccessController extends AppController 
{
	var $name = 'Access';
	var $uses = array('User','Profession','Categorysous', 'Location', 'Category', 'Visit');
	var $layout = 'access';
	var $helpers = array('Html','Ajax','Javascript');
	
	
	function beforeFilter () {
		parent::beforeFilter();
		$this->Auth->allow('*');
		App::import('Vendor','colorconverter');
		App::import('Vendor','Access');
		$this->Profession->recursive = 0;
	}
		
	function index($codebar = false, $type = 'enter')
	{
		
		$this->pageTitle = 'Контроль входа читателей';
		
		if( !($this->data || $codebar) ) {
			$user    = false;
			$abon    = false;
			$fotoUrl = false;
			$this->set(compact('user','abon','fotoUrl','type'));
			$this->render('index');
			return;
		}
		
		if($this->data){
			$codebar = $this->data['User']['codbaru'];
		}
		
		$codebar = intval( preg_replace('/\D/','',$codebar) );	
		
		//дополняем код до 6ти символов
		str_pad($codebar,6,'0',STR_PAD_LEFT);
		
		$userInfo = current($this->User->findAllByCodbarU($codebar));
		if(!$userInfo){
			$this->set(compact('user','abon','fotoUrl','type'));
			$this->render('index');
			return ;
		}
		
		list ($sous,$user) = array($userInfo['Souscription'],$userInfo['User']);
		
		$prof = current(current($this->Profession->findAllByIdProfession($user['IdProfession'])));
		$loc  = current(current($this->Location->findAllByIdQuartier($user['IdQuartier'])));
		$univ = current(current($this->Categorysous->findAllByIdCategSocioProf($user['IdCategSocioProf'])));
		$edu  = current(current($this->Category->findAllByIdCategUsager($user['IdCategorie'])));
		
		//delete null values
		$categ = array_diff( array( $edu['IdCategUsager'],
									mb_substr($prof['Libelle'],0,1) . mb_substr($loc['Libelle'],0,1),
									current(explode(' ',$univ['Libelle'])) ),
							 array(null,''));
		$categ = implode('-', $categ);
									
		$fotoUrl = false;
		$user['sexe'] = 'не указан';
		$user['DateNaissance'] = Access::dateParsing($user['DateNaissance']);
		$user['DateInscription'] = Access::dateParsing($user['DateInscription']);
		
		//для нескольких абонементов берется первый валидный
		$finished = false;
		$i = 0;
		$today  = time();
		while (!$finished && $i < count($sous)){
			
			$UsagerSous = &$sous[$i]['UsagerSouscription'];
			
			$starts = strtotime($UsagerSous['DateDebut']);
			$ends   = strtotime($UsagerSous['DateFin']);
	
			// is abonement valid?
			$res = ($starts < $today && $today < $ends);
				
			if($res){
				$abon['name']   = $sous[$i]['Libelle'];
				$abon['starts'] = Access::dateParsing($UsagerSous['DateDebut']);
				$abon['ends']   = Access::dateParsing($UsagerSous['DateFin']);
				//$abon['color']  = colorconverter::changeColor($sous[$i]['IdSouscription']);
				//or
				$abon['color']  = Access::colorFromConfig($sous[$i]['IdSouscription']);
			} else {
				$abon  = false;
			}
			$i++;
			$finished = $res;
		}
		$this->set_user_visit($user, $type);
		$this->set(compact('user','abon','fotoUrl','categ','type'));
		$this->render('index');
	}
	
	function out($codebar = false){
		$this->index($codebar, 'out');
	}
	
	function set_user_visit($user,$type){
		
		$this->Visit->set(array(    
				'IdUsager' => $user['IdUsager'],
				'CodbarU' => $user['CodbarU'],
				'Type' => $type
				));
		$this->Visit->save();
	}
}
?>