<?php

require_once('widgets.inc.php');

App::import('Sanitize');

class NoticesController extends WidgetsController {

	var $name = 'Notices';
	/**
	 * @var Exemplaire
	 */
	var $Exemplaire;

	/**
	 * @var Notice
	 */
	var $Notice;
	
	/**
	 * @var Book
	 */
	var $Book;
	
	//var $view = 'ajax';
	//var $helpers = array('Html','Ajax','Javascript', 'Xml');
	//var $components = array( 'RequestHandler' );
	var $uses = array('NoticeField','Exemplaire','Notice','Book','Matiere','NoticeZ','Exemplaire','Rating');
	
	/**
	 * @var RequestHandlerComponent
	 */
	var $RequestHandler;
	var $helpers = array('Html','Ajax','Javascript', 'Xml', 'Text', 'BookHelper', 'Paginator', 'Cache');
	var $cacheAction = array(
    	'getIsbd/' => '24 hours',
    	'getLiens/' => '24 hours',
    );


	function beforeFilter () {
		parent::beforeFilter();
		$this->Auth->allow('*');
		
		if ($this->RequestHandler->accepts('json')) {
			// Execute json code
			Configure::write('debug', 0);
		}
		/*
		if ($this->RequestHandler->accepts(array('xml', 'rss', 'atom'))) {
		// Executes if the client accepts any of the above: XML, RSS or Atom
		}
		*/
	}

	function index($idNotice = 0, $source = 'default') {
		
		if (empty($this->params['pass'])) {
			$defaults = array('IdNotice'=>0, 'Source'=>'default', 'year'=>'');
			$this->params['named'] = array_merge($defaults, $this->params['named']);
			$idNotice = Sanitize::paranoid($this->params['named']['IdNotice']);
			$source = Sanitize::paranoid($this->params['named']['Source']);
			$year = Sanitize::paranoid($this->params['named']['year']);
		} else {
			$idNotice = Sanitize::paranoid($idNotice);
			$source = Sanitize::paranoid($source);
		}

		if (empty($source)) { $source = 'default'; }
		$this->Book->setDataSource($source);
		$this->NoticeZ->setDataSource($source);
		$this->Exemplaire->setDataSource($source);
		$this->Rating->setDataSource($source);
		// @todo выцеплять года выпусков периодики более "легким" алгоритмом
		$book = $this->Book->read(null, $idNotice);
		
		if($book['Book']['Categ']==4){
			$res = $this->Book->query("select distinct SUBSTRING(valeur, LEN(valeur)-3, 4) as date
				from NOTICE_Z where IdNotice in 
				(select IdNoticeCible from LIEN_NOTICE where IdNoticeSource = $idNotice)
				and idZone = '210' and sZone = 'd'"
			);
			$years = Set::extract('/0/date',$res);
			$this->set('years',$years);
			if ($year=='') $year=max(coalesce($years,$this->viewVars['years']));
		} 
		
		$conditions = array();
		if ($book['Book']['Categ']==4) $conditions = array("Cible.idnotice in (SELECT idNotice FROM [Notice_Z] WHERE [idZone] ='210' AND [sZone]='d' AND [valeur] LIKE N'%$year')");
		
		$this->Book->contain(array('Exemplaire'=>a('Statut','Annexe','Bibliotheque'),
								   'ExemplaireStat',
								   'NoticeZ',
								   'Rating',
								   'Cible'=>array('conditions'=>$conditions, 'NoticeZ'=>array(
								   					'Rating','Exemplaire'=>a('Statut','Annexe','Bibliotheque'))),
								   'Source'=>array('NoticeZ', 'Rating','Exemplaire'=>a('Statut','Annexe','Bibliotheque'))
		));
		
		$book = $this->Book->read(null, $idNotice);
		//$this->_setLmHeaders($book);
		
		foreach ($book["Cible"] as $nom=>$cible){
			if(count($cible['NoticeZ'])==0){
				unset($book["Cible"][$nom]);
			}
		}
		if($year) $this->set('active_year',$year);
		
		
		// Исправления для унификации вида массива книг и Cible книг и Source книг
		$book = $this->_unifRelatedBooks($book,array('Cible','Source'));
	
		$this->set('book', $book);
		$this->set('IdNotice', $book['Book']['IdNotice']);
		$this->set('source', $source);

		//$this->set('Data', $res);
		if ($this->RequestHandler->accepts('json')) {
			$this->render('json', 'ajax');
			return;
		} else {
			$this->render('index');
		}
	}
	
	function _unifRelatedBooks($book,$names){
		if(!is_array($names)){
			$names = array($names);
		}
		foreach ($names as $name){
			foreach ($book[$name] as $key => $value) {
				$temp = $book[$name][$key];
				$book[$name][$key]['Book'] = array(
						'IdNotice' => $temp['IdNotice'],
						'Categ' => $temp['Categ']);
			}
		}
		return $book;
	}

	function search($aRequest = null) {

		if (key_exists('getCount', $this->data)) {
			$getCount = $this->data['getCount'];
		} else {
			$getCount = false;
		}
		$opac_sources = Configure::read('opac_sources');
		// ищется для рубрик каждой базы
		foreach ($this->data as $k=>$data){
			if( in_array($data['field'],array('R600_A','SUJET')) && !empty($data['value']) && (strpos($data['value'],' + ') !== false)){
				$this->data[$k]['field'] = 'R600ID';
				$this->data[$k]['value'] = a();
				foreach ($opac_sources as $source=>$val){
					if(is_array($val)){
						$this->data[$k]['value'][$source] = implode(',',
							$this->Matiere->getIdMatiereRecursive($data['value'],$source));
					}
				}
			}
		}

		$res = $this->NoticeField->getResult($this->data, $getCount);

		if (key_exists('return', $this->params) && $this->params['return']) {
			return $res;
		} else {
			$this->autoRender = false;

			$this->set('TopElement', 'Notices');
			$this->set('Data', $res);

			$this->render('getXml', 'ajax');
		}
		return;
	}

	function getIsbdAjax($IdNotice, $source) {
		$this->set('IdNotice', $IdNotice);
		$this->set('source', $source);
		return;
	}
	
	function getIsbd() {

		$this->loadModel('RemoteNotice');
		$data = $this->params['named'];
		
		/**
		 * @commentby: Alex
		 * @todo send to OPAC_CONFIG configuration parametrs
		 * @see in modules Notice_field.php and search_form.php
		 */
		$opac_config = Configure::read('opac_sources');
		/* @var $opac_config NEW_OPAC_CONFIG */

		$source = Sanitize::paranoid($data['source']);

		$url = $opac_config->GetParam($source, 'ISBD_URL');
		$data['FicLog'] = $opac_config->GetParam($source, 'fic');
		unset($data['url']);
		$data['IdSession'] = 'OPAC';
		$data['IdLangue'] = $this->IdLangue;

		$res = $this->RemoteNotice->request('get', array('data' => $data, 'url' => $url));
		$res_headers = $this->RemoteNotice->getResponseHeaders();//if(strpos($res_headers['Content-Type'], 'charset=Windows-1251') >

		if (key_exists('return', $this->params) && $this->params['return']) {
			return $res;
		} else {
			$this->autoRender = false;

			$this->set('TopElement', 'div');
			$this->set('Data', $res);

			$this->render('getHtml', 'ajax');
		}

		return;

	}

	function getExemplaires() {
		//$this->loadModel('RemoteNotice');
		$this->loadModel('Exemplaire');
		$data = (array)$this->params['url'];

		// Если вызван через requestAction
		if (isset($this->params['requested']) && $this->params['requested']) {
			$data = (array)$this->params['named'];
		}

		$opac_sources = Configure::read('opac_sources');

		$source = Sanitize::paranoid($data['Source']);

		$opac_sources = new NEW_OPAC_CONFIG();

		$url = $opac_sources->GetParam($source, 'exemp_url');
		$IdNotice = Sanitize::paranoid($data['IdNotice']);
		$data['FicLog'] = $opac_sources->GetParam($source, 'fic');

		$this->Exemplaire->setDataSource($source);
		$res = $this->Exemplaire->findAllByIdNotice($IdNotice);

		if (key_exists('return', $this->params) && $this->params['return']) {
			$this->autoRender = true;
		}

		$this->set('TopElement', 'div');
		$this->set('Data', $res);
		//$this->set('pre', $res);
		$this->set('IdNotice',$IdNotice);
		$this->set('source_',$source);
		return;
	}

	/**
	 * возвращает массив экземпляров для описания
	 * если нет экземпляров - false
	 * @return mixed
	 */
	function getExemplarForNotice($idNotice){
		$resWithExemplar = $this->Exemplaire->findAllByIdNotice($idNotice);
		if(count($resWithExemplar)>0){
			return  $resWithExemplar;
		}else{
			return  false;
		}
	}

	function getLiens($idNotice = 0) {
		$source = Sanitize::paranoid($_GET['Source']);
		$idNotice = Sanitize::paranoid($_GET['IdNotice']);

		$this->Notice->setDataSource($source);

		$aLiensUp = $this->Notice->getLiensUp($idNotice);
		$aLiensDown = $this->Notice->getLiensDown($idNotice);

		foreach ($aLiensUp as $key => $value) {
			$aIdLienNotices[] = $value[0]['IdNotice'];
		}

		if (!empty($aIdLienNotices)) {
			$this->Notice->recursive = 0;
			$this->Notice->setSource('view_Notice4Liens');
			$aLiensUp = $this->Notice->find('all', array('conditions'=>array('IdNotice'=>$aIdLienNotices, 
													 'IdLangueSoft'=>$this->IdLangue)));
		}

		$aIdLienNotices = array();
		foreach ($aLiensDown as $key => $value) {
			$aIdLienNotices[] = $value[0]['IdNotice'];
		}

		if (!empty($aIdLienNotices)) {
			$this->Notice->recursive = 0;
			$this->Notice->setSource('view_Notice4Liens');
			$aLiensDown = $this->Notice->find('all', array('conditions'=>array('IdNotice'=>$aIdLienNotices, 
													   'IdLangueSoft'=>$this->IdLangue)));
		}

		$aLiens = array_merge($aLiensUp, $aLiensDown);

		$aLiens = Set::sort($aLiens, '{n}.Notice.200h', 'ASC');

		$aLiens2 = Set::combine($aLiens, '{n}.Notice.IdNotice', '{n}.Notice', '{n}.Notice.Categ');


		if (key_exists('return', $this->params) && $this->params['return']) {
			return $res;
		} else {
			$this->set('TopElement', 'pre');
			$this->set('Data', $aLiens2);
			$this->set('IdNotice',$idNotice);
			$this->set('source',$source);
			$this->layout = 'ajax';
			//$this->autoRender = false;
			//$this->render('getHtml', 'ajax');
		}
	}

	function doRedirect() {
		$idNotice = intval($this->params['named']['IdNotice']);
		$source = Sanitize::paranoid($this->params['named']['Source']);
		$requestedUrl = $this->params['named']['DetailPageURL'];
				
		if (is_numeric($requestedUrl)) {
			$new_opac_config = Configure::read('opac_sources');
			$eLibUrl = $new_opac_config->getParam($source, 'eLibUrl');
			$url = vsprintf($eLibUrl, array($idNotice,$requestedUrl,$source));
			$this->header('Location: ' . $url, true);
			exit;
		} else {
			$url = $requestedUrl;
			$url.= '//'.implode('/',$this->params['pass']);
			$this->Notice->setDataSource($source);
			// @todo во избежание дыры проверка, 
			// действительно есть такой URL для этого IdNotice или нет
 			$safeUrl = $this->Notice->checkUrlExists($idNotice, $url);	
 			
			if ($safeUrl) {			
				$this->header('Location: ' . $url, true);
			} else {
				$this->flash(__('Запрошенный адрес URL не указан как адрес электронной версии данного документа!'));;
			}
			exit;
		}
	}
	
	function comment($IdNotice = null) {
		if (!is_array($this->data)) {
			$this->setErrorFlash(__('Ошибка при отправке данных формы', true));	
			return;
		}
		
		$IdNotice = Sanitize::paranoid(Set::extract('Book.IdNotice', $this->data));
		
		if (empty($IdNotice)) {
			$this->setErrorFlash(__('Ошибка при отправке данных формы - не указан идентификатор', true));	
			return;
		}
		
		if (!empty($this->data['Comment'])) {
			if ($this->Book->createComment($IdNotice, $this->data)){
				$this->setGreenFlash(__('Post was commented on', true));
				$this->redirect(array('action' => 'index', $IdNotice), 200, true);
			} else {
				$this->setErrorFlash(__('Post could not be commented on. Perhaps you left a field empty?', true));
				$this->redirect(array('action' => 'index', $IdNotice), 200, true);
			}
		}
	}
	
	/**
	 * Set document last modified information 
	 * If not modified - return 304 and exit
	 * @param array $book
	 */
	function _setLmHeaders($book){
		$last_modif = coalesce($book['Book']['DateCreation'],$book['Book']['DateMaj'],strftime('%Y-%m-%d %H:%M:%S',filemtime(__FILE__)));
		list($date,$time) = explode(' ',$last_modif);
		list($year,$month,$day) = explode('-',$date);
		list($h,$m,$s) = explode(':',$time);
		$month =  date("M", mktime(0, 0, 0, $month, 1, 2010));

		$server_lm = $_SERVER['HTTP_IF_MODIFIED_SINCE'];

		if (isset($server_lm) && strtotime($server_lm)>= $last_modif){
			header('HTTP/1.1 304 Not Modified');
			exit;
		}

		header('Cache-Control: must-revalidate');
		header('Last-Modified: '."$day $month $year $h:$m:$s".' GMT');
	}

}