<?php
require_once('widgets.inc.php');

class UserCardController extends WidgetsController {

	var $name = 'UserCard';
	var $uses = array(
					 'Exemplaire',
					 'User',
					 'Reservation',
					 'UserNotice',
					 'UserNoticeHist',
					 'Notice',
					 'Pret',
					 'Bookshelf',
					 'PretHistory',
					 'BookshelvesBooks'
					 );
	/**
	 * @var Exemplaire
	 */
	var $Exemplaire;
	/**
	 * @var Notice
	 */
	var $Notice;
	/**
	 * @var User
	 */
	var $User;
	/**
	 * @var Reservation
	 */
	var $Reservation;
	/**
	 * @var Pret
	 */
	var $Pret;	
	/**
	 * @var UserNotice
	 */
	var $UserNotice;
	/**
	 * @var UserNoticeHist
	 */
	var $UserNoticeHist;
	/**
	 * @var PretHistory
	 */
	var $PretHistory;
	/**
	 * @var Bookshelf
	 */
	var $Bookshelf;
	/**  @var BookshelvesBooks **/
	var $BookshelvesBooks;
	
	
	function beforeFilter() {
		parent::beforeFilter();
		$this->Auth->deny('index');
	}

	function index(){
		$idUser = $this->Auth->user($this->User->primaryKey);
		$userInfo = $this->User->read(null, $idUser);
		
		/* @var $opac_config BASE_SOURCE_CONFIG */
		$opac_config = Configure::read('opac_sources');
		$CutomizationCode = $opac_config->GetParam($source = 'default', 'CutomizationCode');
		if (mb_strtolower($CutomizationCode) == 'turg') { 
			$idUser = $this->User->findAllIds($this->Auth->user('CodbarU'));
		};
		
		$conditions = array('IdUsager'=>$idUser);
		
		// Для использования в contain
		$exemp_with_notice = array('Exemplaire'=>array('Notice'=>array('NoticeZ')));

		$this->Reservation->contain(array('ExemplaireResa'=>$exemp_with_notice));
		$reservations = $this->Reservation->find('all', compact('conditions'));
		
		$this->Pret->contain($exemp_with_notice);
		$prets = $this->Pret->find('all', compact('conditions'));
		$holdsIdPret = Set::extract('/0/IdPret', $this->Pret->getHoldOverExemplaires($idUser));
			
		$this->set(compact('userInfo','prets','reservations', 'holdsIdPret'));

	}
	
	function history(){
		$idUser = $this->Auth->user($this->User->primaryKey);
		
		$this->paginate = array(
			'limit' => 25,
			'conditions' => array("PretHistory.IdUsager" => $idUser),
			'contain' => array('Exemplaire'=>array('Book'=>array('NoticeZ','Rating'))),
			'order' => array('PretHistory.DatePret ' => 'DESC')
		);
		$histPrets = $this->paginate('PretHistory');

		$this->paginate = array(
			'limit' => 25,
			'conditions' => array("Reservation.IdUsager" => $idUser),
			'contain' => array('Book'=>array('NoticeZ','Rating')),
			'order' => array('Reservation.DateResa' => 'DESC')
		);
		$reservations = $this->paginate('Reservation');
		
		$this->set(compact('histPrets','prets','reservations'));
	}
	
	function addbook($sources = null, $shelf_id = null) {
		// пришло от поика
		if(!$sources){
			$sources = $this->params['form'];
		}
		// пришло от катрочки описаиня
		if(!$sources){
			$named = & $this->params['named'];
			if($named['Source'] && $named['IdNotice'])
				$sources[$named['Source']] = $named['IdNotice'];
		}
		if (!$sources) {
			$this->Session->setFlash(__('Неправильная книга', true));
			$this->redirect(array('action'=>'index'));
		}
		// если вместо $sources где то передаётся idNotice
		// todo для дальнейшего использования везде передавать в формате
		// источник=>ids а эту проверку убрать!
		if(!is_array($sources)){
			$sources = array('default'=>$sources);
		}
			
		$user_id = $this->Auth->user($this->User->primaryKey);
		$conditions = array('user_id'=>$user_id, 'is_default' => 1);
		$order = array('is_default');
		$shelf = $this->Bookshelf->find('first', compact('conditions', 'order'));
		if (empty($shelf)) {
			$shelf = $this->Bookshelf->createFirstBookshelf($user_id);
		} 
		
		$shelf_id = $shelf['Bookshelf']['id'];
		$existed_books = array();
		$added_books = array();
		$notAdded_books = array();
		
		foreach($sources as $source=>$ids){
			// через post могли быть переданы другие параметры - отсеиваем их
			if(!$this->isSourceExist($source)) continue;
			
			$book_ids  = explode(',',$ids);
			$total     = count($book_ids);
			foreach ($book_ids as $book_id){
				if(! $book_id = intval($book_id) ) continue;
				$conditions = array('bookshelf_id' => $shelf_id,
									'notice_id'=> $book_id,
									'source'=> $source);
				//может и книга уже на полке. Проверим.
				/**
				 * @todo Можно не делать новые запросы, а проверять по массиву $shelf['Book']
				 *       с помощью Set::extract 
				 *       (массив уже заполнен при  $this->Bookshelf->find();
				 *        а если $shelf['Book'] пуст (например, полка только что создана) то можно вообще не проверять
				 */
				if ($this->BookshelvesBooks->findCount($conditions) > 0){
					$existed_books[] = $book_id;
					continue;
				}
				$this->BookshelvesBooks->create();
				if(!$this->BookshelvesBooks->save($conditions)){	
					$notAdded_books[] = $book_id;
				}
				$added_books[] = $book_id;
			}
		}
		
		$msg = '';
		if(count($existed_books) > 0){
			$msg .= __('Некоторые документы уже есть на Вашей полке! ', true);
		}
		$msg .= (count($added_books) == $total) ? __('Добавление прошло успешно ',true) : __('Некоторые документы не были добавлены',true);
		
		$this->Session->setFlash($msg);

		$this->redirect(array('controller'=>'bookshelves','action'=>'view', 'id'=>$shelf_id));
		return;
	}
}
?>