<?php
class Book extends AppModel {

	var $name = 'book';
	var $useTable = 'Notice';
	var $primaryKey = 'IdNotice';
//	var $actsAs = array('Containable', 'Commentable.Commentable');
	var $actsAs = array('Containable');

	var $hasMany = array(

	'Exemplaire' => array(
	  'className' => 'Exemplaire',
	  'foreignKey' => 'IdNotice'
	),

	'NoticeZ'=>array(
	'className' => 'NoticeZ',
	'foreignKey' => 'IdNotice'
	),
	);

	var $hasOne = array(
	'Rating' =>array(
	  'className' => 'Rating',
	  'foreignKey' => 'notice_id',
	  'fields'     => array('rating','numVotes','viewed', 'votes'),
	),
	'ExemplaireStat' => array(
		'classname' => 'ExemplaireStat',
		'foreignKey' => 'idNotice',
		'fields'     => array('countAll', 'Pretable', 'Reservable'),
	)
	);
	
	var $hasAndBelongsToMany = array(
		'Cible' => array(
			'className' => 'Book',
			'joinTable' => 'lien_notice',
			'foreignKey' => 'IdNoticeSource',
			'associationForeignKey' => 'IdNoticeCible',
			'unique' => false,
			'conditions' => '',
			'fields' => '',
			'order' => '[LienNotice].[NumOrdre] desc',
			'limit' => '',
			'offset' => '',
			'finderQuery' => '',
			'deleteQuery' => '',
			'insertQuery' => ''
		),
		'Source' => array(
			'className' => 'Book',
			'joinTable' => 'lien_notice',
			'foreignKey' => 'IdNoticeCible',
			'associationForeignKey' => 'IdNoticeSource',
			'unique' => false,
			'conditions' => '',
			'fields' => '',
			'order' => '',
			'limit' => '',
			'offset' => '',
			'finderQuery' => '',
			'deleteQuery' => '',
			'insertQuery' => ''
		));
	
	var $arrivals = array();
	
	// Добавляем в массив найденных данных о книгах URL на полное описание 
	// 
	function afterFind($results, $primary = false) {
		foreach ($results as $key => $book){

			if (isset($book[$this->alias]['IdNotice']) /*&& $primary*/) {
				$results[$key]['detail_url'] = array(
					'controller'=>'notices',
					'action'=>'index',
					'IdNotice'=>$book['Book']['IdNotice'],
					'Source'=>$this->useDbConfig);
			}
		}
		return $results;
	}
	
	function findCategories() {
		$data = array(__('Книги',true)=>array(1,9),
					  __('Периодические издания',true)=>4,
					  __('Многотомники',true) =>9, 
					  __('Электронные издания (на CD, DVD, в Интернет и т.п.)',true)=>30
		);
		//$data['Другие'] = -1;
		
		return array('Categories'=>$data);
	}
	
	function getSqlArrivalsDates() {
		extract($this->arrivals);
		
		$functions = array(
			'all' =>'F_START_OF_DAY',
			'd' =>'F_START_OF_DAY',
			'wk'=>'F_START_OF_WEEK',
			'm' =>'F_START_OF_MONTH'
		);
		
		switch ($period) {
			case 'wk':
				//$delay[0] = '-'.abs(floor($delay[0]/7)*7);
				$sql_delay_date = "dbo.F_START_OF_DAY(GETDATE(){$delay[0]})";
				$sql_start_date = "dbo.{$functions[$period]}(DATEADD($period, {$delay[1]}, $sql_delay_date))";
				$sql_end_date   = "dbo.{$functions[$period]}($sql_delay_date)";
				break;
			case 'm':
				//$delay[3]='-'.abs($delay[2]+1);
				$delay[3] = $delay[2]+1;
				$sql_delay_date = "dbo.F_START_OF_DAY(GETDATE(){$delay[0]})";
				$sql_start_date = "dbo.{$functions[$period]}(DATEADD($period, {$delay[2]}, $sql_delay_date))";
				$sql_end_date   = "dbo.{$functions[$period]}(DATEADD($period, {$delay[3]}, $sql_delay_date))";
				break;
			case 'd':
			default:
				$period = 'd'; // чтобы не было ошибки в SQL DATEADD
				$sql_delay_date = "dbo.F_START_OF_DAY(GETDATE(){$delay[0]})";
				$sql_start_date = "dbo.{$functions[$period]}(DATEADD($period, -1, $sql_delay_date))";
				$sql_end_date   = "dbo.{$functions[$period]}($sql_delay_date)";
				break;
		}	
		
		return array($sql_delay_date, $sql_start_date, $sql_end_date);
	}
	
	function findArrivalDates() {
		$fields = $this->getSqlArrivalsDates();
		foreach ($fields as $key=>$def) {
			$fields[$key] = "CONVERT(varchar, $def, 105)";
		};
		
		return $this->query('SELECT '.implode(', ', $fields));
	}
	
	function beforeFind($queryData) {
		if (empty($this->arrivals)) return true;
		
		list($sql_delay_date, $sql_start_date, $sql_end_date) = $this->getSqlArrivalsDates();
		
		if ($this->arrivals['period'] == 'all'){
			$delay = $this->arrivals['delay'];
			$list_delay = Configure::read('opac.book.arrival_list_len');
			$list_delay = (intval($list_delay) > 0) ? $list_delay : 365;
			$sql_start_date = 'dbo.F_START_OF_DAY(DATEADD(d, '.-$list_delay.', dbo.F_START_OF_DAY(GETDATE()'.$delay[0].')))';
			$sql_end_date = 'dbo.F_START_OF_DAY(dbo.F_START_OF_DAY(GETDATE()'.$delay[0].'))';
		}
		$filter = coalesce(Configure::read('opac.book.arrival_filter_by'), 'Notice.DateCreation');
		list($table, $field) = explode('.', $filter);
		$table = ($table == 'Notice') ? 'Book' : $table;
		
		$add = array('conditions' => array(
		  		"$table.$field >= $sql_start_date",
		  		"$table.$field < $sql_end_date"
		  		)
		  	);
			  	
		// else add time filter
		$queryData = array_merge_recursive($queryData, $add);
		return $queryData;
	}
}
?>