<?php
class Bookshelf extends AppModel {

	var $name = 'Bookshelf';
	var $primaryKey = 'id';
	var $actsAs = array('Containable');
	
	var $hasAndBelongsToMany = array(
		'Book' => array(
			'className' => 'Book',
			'joinTable' => 'bookshelves_books',
			'foreignKey' => 'bookshelf_id',
			'associationForeignKey' => 'notice_id',
			'unique' => false,
			'conditions' => '',
			'fields' => '',
			'order' => '',
			'limit' => '',
			'offset' => '',
			'finderQuery' => '',
			'deleteQuery' => '',
			'insertQuery' => ''
	));
	
	var $belongsTo = array(
		'User' => array(
			'className' => 'User',
			'foreignKey' => 'user_id',
			'fields'=> array('Nom','Prenom','CodbarU','IdUsager')
		)
	);
	
	function createFirstBookshelf($user_id) {
		$data = array();
		$data['Bookshelf'] = array('id'=>null,'libelle'=>__('Основная полка', true), 'user_id'=>$user_id, 'is_default' => 1);
		return $this->save($data);
	}
	
	function resetDefault($user_id){
		return $this->updateAll(
			array('is_default' => 0),
			array('user_id' => $user_id)
		);
	}
}
?>