<?php
class KnigobMatiere extends AppModel {
	var $name = 'KnigobMatiere';
	var $primaryKey = 'IdMatiere';
	
	//The Associations below have been created with all possible keys, those that are not needed can be removed
	var $hasAndBelongsToMany = array(
		'book' => array(
			'className' => 'KnigobViewBook',
			'joinTable' => 'knigob_matieres_books',
			'foreignKey' => 'IdMatiere',
			'associationForeignKey' => 'IdNotice',
			'unique' => true,
			'conditions' => '',
			'fields' => '',
			'order' => '',
			'limit' => '',
			'offset' => '',
			'finderQuery' => '',
			'deleteQuery' => '',
			'insertQuery' => ''
		)
	);
	
	function getKnigob($IdMatiere, $IdTerm) {
		$odd = $IdTerm % 2;
		$query = "SELECT kbs.StudSum, kne.ExempCount
				FROM knigob_books_students AS kbs 
				INNER JOIN knigob_notice_exemplaire AS kne ON kbs.IdNotice = kne.IdNotice
				WHERE kbs.odd = $odd AND kne.IdNotice IN (SELECT kmb.IdNotice FROM dbo.knigob_matieres_books kmb WHERE kmb.IdMatiere = $IdMatiere)";
		$res = $this->query($query);
		$exemp = Set::extract('{n}.0.ExempCount',$res);
		$stud  = Set::extract('{n}.0.StudSum',$res);
		
		$knigoob = 0;
		for ($i=0;$i<count($stud);$i++) {
			if (!empty($stud)) $knigoob += $exemp[$i]/$stud[$i];
		}
			
		return $knigoob;
		
	}

	function beforeFind($queryData) {
		parent::beforeFind();
		$opac_config = Configure::read('opac_sources');
		$id_thesaurus_disc = $opac_config->GetParam('default', 'KNIGOB_ID_THESAURUS_DISC');
		$queryData['conditions'][] = array('IdThesaurus' => $id_thesaurus_disc);
		return $queryData;
	}
}
?>