<?php
class KnigobViewBook extends AppModel {

	var $name = 'KnigobViewBook';
	var $primaryKey = 'IdNotice';
	
	var $hasMany = array(
		'students' => array(
			'className' => 'KnigobBooksStudent',
			'foreignKey' => 'IdNotice'
		)
	);

	function beforeFind($queryData) {
		parent::beforeFind();
		$queryData['conditions'][] = array('Categ' => 1);
		return $queryData;
	}

	function findAllByIdMatiere($IdMatiere) {
		$sql = '
		SELECT NOTICE.IdNotice, NOTICE.Categ,   
				CASE
     				WHEN view_200fg.Valeur IS NOT NULL THEN view_200fg.Valeur
	 				ELSE v200g.Valeur END AS Auteur,
					v200a.Valeur AS Titre,  
					view_210c.Valeur AS Editeur, 
					CAST(dbo.fn_RIID_NOTICE_VALEUR(NOTICE.IdNotice, \'210\', \'d\', 0) AS nvarchar(max)) AS Date,  
					v01x.Valeur AS ISBN,
					CAST(dbo.fn_RIID_COTE_NOTICE(NOTICE.IdNotice, 1) AS nvarchar(50)) AS Cote,  
					v856u.Valeur AS URL,
					ROW_NUMBER() OVER (ORDER BY Titre) AS RowNumber,
					---Exemplares---  
					_CATEG_NOTICE.Image, CAST(_CATEG_NOTICE.Libelle AS nvarchar(255)) AS Libelle,
					nex.ExempCount, nex.Prix, nex.SumPrix 
					FROM NOTICE INNER JOIN _CATEG_NOTICE ON NOTICE.Categ = _CATEG_NOTICE.IdCategNotice AND (_CATEG_NOTICE.IdLangueSoft = '.$this->IdLangue.')
					LEFT JOIN dbo.view_NOTICE_200a_100char v200a  ON v200a.IdNotice = NOTICE.IdNotice 
					LEFT JOIN view_200fg  ON view_200fg.IdNotice = NOTICE.IdNotice AND view_200fg.sZone = \'f\'
					LEFT JOIN view_200fg v200g  ON v200g.IdNotice = NOTICE.IdNotice AND v200g.sZone = \'g\' AND v200g.NumOrdre = 0
					LEFT JOIN view_210c  ON view_210c.IdNotice = NOTICE.IdNotice AND view_210c.NumOrdre = 0
					LEFT JOIN view_NOTICE_01x v01x  ON v01x.IdNotice = NOTICE.IdNotice AND v01x.sZone = N\'a\' AND v01x.IdZone = N\'010\' AND (v01x.NumOrdre IS NULL OR v01x.NumOrdre = 0) 
					LEFT JOIN view_NOTICE_856u v856u  ON v856u.IdNotice = NOTICE.IdNotice AND v856u.NumOrdre = 0
					LEFT JOIN [knigob_notice_exemplaire] nex ON nex.IdNotice = NOTICE.IdNotice
					WHERE NOTICE.IdNotice IN (select IdNotice FROM knigob_matieres_books KnigobMatieresBook WHERE KnigobMatieresBook.IdMatiere = %d)';
		$sql = sprintf($sql, $IdMatiere);
		return $this->query($sql);
	}
}
?>