<?php
class LienMatiere extends AppModel {

	var $name = 'LienMatiere';
	var $useTable = 'LienMatiere';
	var $primaryKey = 'IdLien';
	var $validate = array(
		'IdLien' => array('numeric'),
		'IdMatiereParent' => array('numeric'),
		'IdMatiereChild' => array('numeric')
	);
	
	function beforeFind($queryData) {
		parent::beforeFind();
		$opac_config = Configure::read('opac_sources');
		//$id_thesaurus_disc = $opac_config->GetParam('default', 'KNIGOB_ID_THESAURUS_DISC');
		
		// Необходимо, чтобы при использовании типа поиска list
		// корректно использовался вычисляемый столбец
		//
		if(key_exists('list', $queryData)) {
			$path = explode('AS', $queryData['list']['valuePath']);
			$queryData['list']['valuePath'] = '{n}.0.'.trim($path[1]);
		}		
		
		return $queryData;
	}
	
	/**
	 * Функция подсчитывает количество описаний в указанной рубрике(ах)
	 * Подсчет ведется с учетом описаний в подрубриках (по умолчанию, при $recursive = true)
	 * или без учета подрубрик 
	 * 
	 * @todo без учета подрубрик
	 *
	 * @param mixed   $id - идентификатор рубрики или массив идентификаторов
	 * @param boolean $recursive - учет описаний в подрубриках при подсчете
	 * @return array
	 */
	function getNoticeCount($id, $recursive = true) {
		$options = array();
		
		$options['joins'] = array(
		array(
		'table' => 'NOTICE_Z',
		'alias' => 'MatieresBooks',
		'type'  => 'inner',
		'conditions' => array('LienMatiere.IdMatiereChild = MatieresBooks.ValeurN', 'MatieresBooks.IdZone'=> 'R600', 'MatieresBooks.sZone' => 'a'),
		));
		$options['conditions'] = array('LienMatiere.IdMatiereParent' => $id);
		$options['fields'] = array('LienMatiere.IdMatiereParent',"COUNT(DISTINCT MatieresBooks.IdNotice) AS books_count");
		$options['group']  = array('LienMatiere.IdMatiereParent');
		
		return $this->find('list', $options);
	}

}
?>