<?php
class NoticeField extends AppModel
{
	var $name = 'NoticeField';
	var $useTable = 'Notice';
	var $_aFieldCond = array();
	
	/** @var  Matiere */
	var $Matiere;
	var $hasMany = array('Exemplaire' => array(
							'className' => 'Exemplaire',
							'foreignKey' => 'IdExemplaire'
	));
	/**
	 * параметры для поиска экземпляров
	 * @var array
	 */
	var $_exemplarParam = array();
	/**
	 * Дополнительные параметры поиска
	 * @var array 
	 */
	var $_addConditions = array();
	
	function _parseSimpleConditions($aConditions, $getCount = false) {
		App::import('Vendor', 'liber');

		$my_config = &FieldOptions::getInstance();
		$my_config -> InitConfig();

		$last_field = '';
		$request = array();
		$subrequest = array();
		$oper_between_fields = array();

		foreach ($aConditions as $condition) {
			if (empty($condition['value'])) continue;
			if ($condition['field']=='R600ID') continue;
			$_cond = new SimpeCondition($condition);
			$_oper = new Operation($condition);
			
			if (!empty($last_field) && $last_field == $condition['field']) {
				$subrequest[] = $_cond->getSqlRequest();
			} else {
				if (!empty($last_oper)) $request[][$last_oper] = $subrequest;
				$subrequest = array();
				$subrequest[] = $_cond->getSqlRequest();
				$oper_between_fields[] = $_oper->getSqlOper();
			}

			$last_field = $condition['field'];
			$last_oper = $_oper->getSqlOper();

		}

		// последний операнд, прибавляемый к последнему запросу в массиве - пустой
		$oper_between_fields[] = '';

		if (!empty($subrequest)) { $request[][$last_oper] = $subrequest; };

		foreach ($request as $subreq) {
			$sql = implode(' '.key($subreq).' ', $subreq[key($subreq)]);
			$sql = '('.$sql.')';
			$res[] = $sql;
		}

		$req = new OpacRequest();
		$req->ReqCond = '';
		if($res){
			foreach ($res as $i => $r) {
				$req->ReqCond.= $r.' '.$oper_between_fields[$i+1].' ';
			}
		}
		
		$sql = $req -> genBooksSearchSQL($this->_exemplarParam, $getCount);
		if($req->ReqCond == '') $sql = str_replace('#addition_cond#','WHERE 1=1 #addition_cond#',$sql);
		return $sql;
	}

	function getResult($aConditions, $getCount = false) {
		// формирование

		// Временное решение для поиска по рубрике и подрубрикам
		foreach ($aConditions as $key => $value) {
			if (is_array($value) && key_exists('field', $value)) {
				$aConditions[$key]['field'] = str_replace('R600_A', 'SujetRech', $aConditions[$key]['field']);
				$aConditions[$key]['field'] = str_replace('SUJET', 'SujetRech', $aConditions[$key]['field']);
			}
		}

		// Удаляем фильтры по экземпляру и т.п. из массива условий
		if(is_array($aConditions['Notice']['Categ'])){
			$doc_types = $aConditions['Notice']['Categ'];
			unset($aConditions['Notice']['Categ']);
		}
		list($aConditions, $this->_exemplarParam) = $this->_parseCondition($aConditions);

		if(Configure::read()) {
			AppController::log('***Search array condition:***', 'searches');
			AppController::log(print_r($aConditions, true), 'searches');
		}
		
		// проверка на непустой запрос
		$req = '';
		foreach ($aConditions as $cond){
			$req .= $cond['value'];
		}
		if(str_replace('*','',$req) == ''){
			$res['total'] = 0; 
			return $res;
		}

		
		$sql = $this->_parseSimpleConditions($aConditions, $getCount);

		foreach ($aConditions as $elem){
			if (is_array($elem) && !empty($elem['field']) ) {
				$allControls[$elem['field']] = '' ;
			}
		}

		$opac_config = Configure::read('opac_sources');
		/* @var $opac_config NEW_OPAC_CONFIG */
		$noticeCount = 0;
		$res = array();

		foreach ($opac_config->GetSources() as $source => $source_config) {
			$dbsource = $source_config['db'];
			$this->setDataSource($dbsource);
			
			$this->_addMatiereCond($aConditions,$source);
			$this->_addCategCond($doc_types);
			$exemp_params = $this->_exemplarParam["libs"][$source];

			// к следующей библиотеке, если для данной ничего не надо искать
			if(!$this->_isSearchInLib($exemp_params)){
				continue;
			}

			$isSearchExemplares = $this->_isWithExemplaire($exemp_params);

			// дополнительные параметры по филиалам
			$query = str_replace('---Exemplares---',$this->_getExemplareCondinion($exemp_params,$isSearchExemplares),$sql);
			$query = str_replace('#addition_cond#', implode(' ',$this->_addConditions),$query);
			if( ! $res_from_current = $this->query($query)){
				continue;
			}
			
			// get exemplaire data
			$this->Exemplaire->setDataSource($dbsource);
			$exemp = $this->Exemplaire->findAllByIdNotices(Set::extract('/0/IdNotice', $res_from_current));

			$ex2 = Set::combine($exemp,'/Exemplaire/IdNotice', '/0');
			
			//reset($res_from_current);
			foreach ($res_from_current as $key=>$row) {
				if (isset($ex2[$row[0]['IdNotice']]))
				$res_from_current[$key][0] = array_merge_recursive($row[0], $ex2[$row[0]['IdNotice']][0]);
			}
			//reset($res_from_current);

			// переформировка массива
			$res_from_current = $this->getAllNotice($res_from_current);
			
			$noticeCount += count($res_from_current);

			// @todo если $res_from_current пусто (array[0]), то
			// в результатах будет пустая строка для данной библиотеки
			$res_from_current2['source'] = array(
				'name' => $source,
				'title' => $opac_config->GetParam($source, HUMAN_NAME),
				'notice' => $res_from_current);
			if (empty($res_from_current)) {
				unset($res_from_current2['source']['notice']);
			}
			if (is_array($res_from_current2)) {
				$res[] = $res_from_current2;
			}
		}
		$res['total'] = $noticeCount;
		return $res;
	}

	/**
	 * Проверяет нуцжно ли выполнять поиск по экземплярам 
	 *
	 * @param array $condition - параметры поиска по полям
	 * @param array $filials - параметры поиска по филиалам
	 * @return bool
	 */
	function _isWithExemplaire($filials){
		$aChecked = array_keys($filials, 1);
		if (count($aChecked) == 1 && in_array('all', $aChecked)) {
			return false;
		}
		return true;
	}
	/**
	 * Проверяет нужно ли осуществлять поиск по текущей библиотеке
	 *
	 * @param array $lib - список параметров поиска по филиалам
	 * @return bool
	 */
	function _isSearchInLib($lib){
		if (!is_array($lib)) return false;

		foreach ($lib as $isSearch){
			if($isSearch) return true;
		}
		return false;
	}

	/**
	 * Удаляет параметры расширенного поиска
	 * из $aConditions, формируя из них
	 * новый массив $this->_exemplarParam
	 * 
	 * @param &array $aConditions
	 */
	function _parseCondition($aConditions){
		// сюда добавлять новые критерии поиска // поиск по:
		$arExempalParam = array('libs','__findAll');
		$exempRequest = array();

		foreach ($arExempalParam as $parametr){
			// параметры поиска в новую переменную
			if(array_key_exists($parametr,$aConditions)){
				$exempRequest[$parametr] = $aConditions[$parametr];
				unset($aConditions[$parametr]);
			}
		}

		if (key_exists('exist', $aConditions)) {
			$aBoolCond = $aConditions['exist'];
			foreach ($aBoolCond as $key => $value) {
				if ($value=='1') {
					$aConditions[] = array('field'=>$key,'oper'=>'AND','value'=>'%');
				}
			}
			unset($aConditions['exist']);
		}

		if (key_exists('between', $aConditions)) {
			$aBetweenCond = $aConditions['between'];
			foreach ($aBetweenCond as $key => $value) {
				if (!empty($value['start'])) {
					$aConditions[] = array('field'=>$key,'oper'=>'AND','value'=>'>='.$value['start']);
				}
				if (!empty($value['end'])) {
					$aConditions[] = array('field'=>$key,'oper'=>'AND','value'=>'<='.$value['end']);
				}				
			}
			unset($aConditions['exist']);
		}

		if (key_exists('Notice', $aConditions)) {
			$aNoticeCond = $aConditions['Notice'];
			foreach ($aNoticeCond as $key => $value) {
				$aConditions[] = array('field'=>'clez'.$key,'oper'=>'AND','value'=>$value);
			}
			unset($aConditions['Notice']);
		}

		return array($aConditions, $exempRequest);
	}

	/**
	 * Возвращает отформатированный массив
	 * записей с экземплярами
	 * из массива $res_from_current 
	 *
	 * @param array $res_from_current
	 * @return array Отформатированный массив 
	 */
	function getNoticeWithExemplare($res_from_current){
		return $this->getAllNotice($res_from_current,true);
	}

	/**
	 * Возвращает отформатированный массив записей
	 * из массива $res_from_current
	 *
	 * @param array $res_from_current
	 * @param bool $withExemplar
	 * @return array Отформатированный массив
	 */
	function getAllNotice($res_from_current,$withExemplar=false){
		$res_from_current_return = a();

		foreach ($res_from_current as $key => $value) {
			$value 		= $value[0];
			$addNotice 	= true;

			if($withExemplar){
				$isExemplars = $value['NbrEx'];
				if(!$isExemplars){
					$addNotice = false;
				}
			}
			unset($value[0]);
			if($addNotice){
				$res_from_current_return[$key] = $value;
			}
			next($res_from_current);
		}

		return $res_from_current_return;
	}
	
	function _addMatiereCond($aConditions,$source){
		foreach ($aConditions as $cond){
			if($cond['field'] == 'R600ID'){
				$id = $cond['value'][$source];
				if(!$id) continue;
				$this->_addConditions[] = 'AND NOTICE.IdNotice IN (
					SELECT IdNotice FROM NOTICE_Z WHERE (IdZone = \'R600\') AND (sZone = \'a\') AND ValeurN  in ('.$id.')) ';
			}
		}
	}
	
	function _addCategCond($categs){
		if(!$categs || ($categs['all'] == 1)) return;
		
		unset($categs['all']);
		$categ_ids = array();
		foreach ($categs as $categ_id=>$isSet){
			if($isSet) $categ_ids[] = $categ_id;
		}
		if(count($categ_ids)==0) return;
		
		$this->_addConditions[] = 'AND NOTICE.Categ IN ('.implode(', ',$categ_ids).')';
	}
	
	function _getExemplareCondinion($filial_param,$withExemplaires){
		$filials = '';
		if($filial_param['all'] != 1 || $withExemplaires){
			unset($filial_param['all']);
			$aFilials = array_keys($filial_param, 1);
			if (!empty($aFilials)) {
				$filials = ' (EXEMPLAIRE.idAnnexe IN ('.implode(',', $aFilials) .'))';
			}
		}
		if($withExemplaires){
			$this->_addConditions[] = 'AND NOTICE.IdNotice IN (
				SELECT IdNotice FROM EXEMPLAIRE WHERE ('.$filials.'))';
		}
		
		$empCond = 'EXEMPLAIRE.idnotice = NOTICE.IdNotice '.( (!empty($filials))? ' AND '.$filials : '' );

		return '(SELECT COUNT(*) FROM EXEMPLAIRE WHERE '.$empCond.' ) AS NbrEx,
				(SELECT COUNT(PRET.IdExemplaire) FROM PRET WHERE PRET.IdExemplaire IN (SELECT IdExemplaire FROM EXEMPLAIRE WHERE '.$empCond.' )) as pretable,
				(SELECT COUNT(EXEMPLAIRE_RESA.IdExemplaire) FROM EXEMPLAIRE_RESA WHERE EXEMPLAIRE_RESA.IdExemplaire IN (SELECT IdExemplaire FROM EXEMPLAIRE WHERE '.$empCond.' )) as reserved,';
	}
}
