<?php
class Pret extends AppModel {

	var $name = 'Pret';
	var $useTable = 'PRET';
	var $primaryKey = 'IdPret';
	var $actsAs = array('Containable');

	//The Associations below have been created with all possible keys, those that are not needed can be removed
	var $belongsTo = array(
		'Exemplaire' => array(
			'className' => 'Exemplaire',
			'foreignKey' => 'IdExemplaire',
			'conditions' => '',
			'fields' => '',
			'order' => ''
		)
	);
	
	function getHoldOverExemplaires($IdUsager) {
		$oper = '=';
		if (is_array($IdUsager)) { 
			$oper = ' IN '; 
			$IdUsager = implode(', ', $IdUsager);
		};
		// Проверка задолженности
		//
		$ReqHoldOverExemplaires = "
		SELECT p.*, PP.*, DATEDIFF(dd,DatePreRestitution, GETDATE()) as DaysOfHoldOver 
		FROM Pret p 
			INNER JOIN Tarif t ON p.IdTarif = t.IdTarif
			INNER JOIN PENAL_PRET PP ON t.IdPenalPret = PP.IdPenalPret
		WHERE IdUsager $oper ($IdUsager) AND 
			DatePreRestitution < GETDATE()
		AND 
			DATEDIFF(dd, DatePreRestitution, GETDATE()) > Delai";  
		return $this->query($ReqHoldOverExemplaires);
	}

}
?>