<?php

class SearchForm extends AppModel
{
	var $name = 'SearchForm';
	var $useTable 	= 'Paramopac_det';

	function getControls($RechId) {
		$opac_config = Configure::read('opac_sources');
		switch ($RechId){
			case 1: $param = 'SIMPLE_FORM_CONTROLS'; 	break;
			case 2: $param = 'EXTENDED_FORM_CONTROLS'; break;
			default: $param = 'SIMPLE_FORM_CONTROLS';
		}
			
		/* @var $opac_config NEW_OPAC_CONFIG */
		return $opac_config->GetParam('default', $param);
	}

	function getAllControls($RechId) {
		$Param_opac = $this->findAll(array('IdRecherche'=>$RechId, 'Visible' => true));
		$res = Set::combine($Param_opac, '{n}.SearchForm.NomChamp', '{n}.SearchForm.LibelleOpac');
		foreach ($res as $id => $name){
			$res[$id]  = __($name,true);
		}
		return $res;
	}

	/**
	 * Чекбоксы для поисковой формы
	 * @todo загружать из БД или другого места
	 * @return array чекбоксы
	 */
	function getCheckboxes(){
		return array('1' => array(
		'text'		=> __('Поиск по экземплярам',true),
		'name'		=> 'withExemplars',
		'visible'	=> false,
		'cond'		=> array(
		'onClick' => 'EnableFilial()',
		'checked' => true,
		)
		),
		'2' => array(
		'text'		=> __('Поиск по всем филиалам',true),
		'name'		=> '__findAll',
		'visible'	=> true,
		'cond'		=> array(
		'onClick' => 'selectFilials()',
		'checked' => false,
		)
		),
		'3' => array(
		'text'		=> __('Инверсия выбора по филиалам',true),
		'name'		=> '__inversFilials',
		'visible'	=> true,
		'cond'		=> array(
		'onClick' => 'filialsInversion()',
		'checked' => false,
		)
		)
		);
	}

	
	function getButtons(){
		return array(
		'2' => array(
		'text'		=> __('Поиск по всем филиалам',true),
		'visible'	=> true,
		'onClick' => 'selectFilials();',
		'class'   => 'button'
		),
		'3' => array(
		'text'		=> __('Инверсия выбора по филиалам',true),
		'visible'	=> true,
		'onClick' => 'filialsInversion()',
		'class'   => 'button'
		)
		);
	}
	
	/**
	 * Возвращает посковые поля по типу документа
	 * @todo  предусмотреть вывода типа, если таковые не совпадают
	 * 		  для различных библиотек
	 * @return array для html элементов select
	 */
	function getDocumentCategFields(){
		$opac_config = Configure::read('opac_sources');
		/* @var $opac_config NEW_OPAC_CONFIG */

		foreach ($opac_config->GetSources() as $name => $source) {
			if ($source['SOURCE_TYPE'] == ST_LOCAL) {
				$this->setDataSource($source['db']);
				$curCategories[$name] = $this->_getCategories();
			}
		}
		// для сохранинея совместимости с исходным алгоритмом
		return $curCategories['default'];
	}

	/**
	 * Возвращает массив из всех типов документа
	 *
	 * @param int $idLanguage - идентификатор языка
	 * @return array 
	 */
	function _getCategories(){
		$sql = "SELECT IdCategNotice as categ, Libelle as name, count(IdCategNotice) as count
				FROM _categ_notice
				LEFT JOIN Notice on Notice.CATEG = _categ_notice.IdCategNotice
				WHERE IdLangueSoft = {$this->IdLangue} and IdCategNotice in (select distinct CATEG from NOTICE)
				GROUP BY IdCategNotice, Libelle
				ORDER BY IdCategNotice";
		
		return Set::combine($this->query($sql),'{n}.0.categ',array('{0} ({1})', '{n}.0.name', '{n}.0.count'));
	}

	/**
	 * Возвращает посковые поля по филиалам
	 *
	 * @return array для html элементов select
	 */
	function getDocumentFilialFields(){
		$sql = "SELECT IdAnnexe, cast(Libelle as nvarchar(50)) as Libelle
				FROM Annexe
				WHERE IdAnnexe > 0 
				ORDER BY Libelle";
		$res = $this->query($sql);
		$arOut = Set::combine($res, '{n}.0.IdAnnexe', '{n}.0.Libelle');
		foreach ($arOut as $id=>$name){
			$arOut[$id] = __($name,true);
		}
		return $arOut;
	}

	/**
	 * Выполняет подключеине ко всем БД
	 * возвращает массив из названия и
	 * списка филиалов для каждой библиотеки
	 *
	 * @return array назваине библиотеки, список филиалов и
	 * 		   параметр visible	
	 */
	function getLibraries(){

		$opac_config = Configure::read('opac_sources');
		/* @var $opac_config NEW_OPAC_CONFIG */
		$res = array();

		foreach ($opac_config->GetSources() as $name => $source) {
			if ($source['SOURCE_TYPE'] == ST_LOCAL) {
				$this->setDataSource($source['db']);
				$library = array();
				$library['confname'] 	= $name;
				$library['name'] 		= __($source[HUMAN_NAME],true);
				$library['filials'] 	= $this->getDocumentFilialFields();
			}

			array_push($res, $library);
		}
		return $res;
	}
}

?>