<?php
class RegistrationController extends UregistrationAppController {
	
    var $name = "Registration";
    var $uses = array('Uregistration.Uruser','Uregistration.UserAddress', 'User');
    var $helpers = array('Html', 'Form', 'BookHelper', 'Javascript','Ajax','Session');
    /**
     * @var Auth
     */
    var $Auth;
    
    var $Session;
    
    var $Uruser;
    
    var $UserAddress;
    
    var $User;

    function beforeFilter(){
            parent::beforeFilter();
            App::import('Core', 'Sanitize');
            $this->Auth->allow('index','success');
    }

    function index() {
    	
    	$this->set('title', __('Самозапись в библиотеку', true));
    	
	    if($this->data){
	    	$this->Uruser->set($this->data);
	    	
	    	if ($this->Uruser->validates()){
	    		
	    		$userId  = $this->Uruser->getMaxUserId();
	    		
	    		$this->data = Sanitize::paranoid($this->data);
	    		
	    		$saveUserInfo = $this->Uruser->addNewUser($this->data, $userId);

	    		if($saveUserInfo){
	    			
	    			if(!is_array($saveUserInfo)){
	    				$this->setErrorFlash($saveUserInfo);
	    				return;
	    			}
	    			
	    			$saveUserAddress = $this->UserAddress->addNewAddress($this->data, $userId);
	    			
	    			$userInfo = $this->User->read(null, $userId);
	    			
	    			$this->set('userInfo', $userInfo);
	    			$this->render('success');
	    		}
	    	} else {
	    	
	    		return;
	    	}	
	    }
    }

    function login() {
    }

    function logout() {
        $this->redirect($this->Auth->logout());
    }
	
    function success(){
        
    }
}
?>