<?php
if(!$isAjax){
	echo $html->css('/css/search_forms.css', null, null, false);
	echo $html->css('jquery.paginate.css', null, null, false);
	echo $html->css('jquery.rating.css', null, array(), false);
	
	$ext = '';
	if (Configure::read() == 0) {
		$ext = '.min';
	}
	// include common 3rd party js
	echo $javascript->link('jquery'.$ext, false);
	echo $javascript->link('/js/rating/jquery.rating.js', false);
	echo $javascript->link('jquery.paginate.js', false);
	echo $javascript->link('jquery.form', false);
	echo $javascript->link('search.js', false);
	
	$form_options = array(
		'success' => "showResult(data)",
		'url' => array('controller'=>'search_forms','action'=>'search'),
		'id' => 'search-form',
		'data'=> 'post_data',
		'before' => "if (!prepareQuery()) return false",
	);
	
	echo '<div id="title"><h3>'.__('Поиск одной строкой ', true).'</h3></div>';
	echo '<div class="query">';
	echo $ajax->form('search-form', 'post', $form_options);
	echo '<div id="search-field">';
		echo $form->input('query', array('label' => __(' ', true),'id'=>'searchQuery', 'div'=>false));
		echo $form->button(__('Поиск', true), array('id'=>'search-btn', 'type'=>'submit'));
	echo '</div>';
	echo '<div id="search-help"></div>';
	echo '<div id="search-stat"></div>';
	echo $form->end();
	echo '</div>';

	echo "<div id='search-progress'><img alt='' src=\"{$javascript->webroot}img/progress.gif\" /></div>";
	echo '<div id="result"></div>';
	return;
}

$tatalDocs = $data['response']['numFound'];
$pages = ($tatalDocs%$limit) ? floor($tatalDocs/$limit)+1 : $tatalDocs/$limit ;

// вывод сообщений об ошибках
// тут не сравнение!
if( $error = getError($data) ){
	echo '<div id="error" >'.$error.'</div>';
	return;
}

$out = array();

// обнуление страницы и добавление отобранных для печати описаний
echo $javascript->codeBlock("
	ids_print = [$ids_print];
	page = 0;
"); 

// функционал для печати
$_isAjax = $isAjax;
$isAjax = false;
$out['printMenu'] = $this->element('printBooks',compact('ids_print','isAjax')).'<br/>';
$isAjax = $_isAjax;

// сортировка
$out['sort'] = sortList($sort,$sortable,$page);

// список документов
$out['list'] = $this->element('BooksList', array('hlight'=>$data['highlighting']));
//$out['list'] = $this->element('ResultListSolr', array('hlight'=>$data['highlighting']));

// пагинация
$out['paginate'] = getPaginate($sort,$pages,$page,$limit, &$javascript);

// статистика
echo getStat($data);

// вывод результатов
foreach ($out as $text_out){
	echo $text_out;
}

function getError($data){
	$error = false;
	if(!is_array($data)){
		$error = __('Ошибка запроса', true);
	}
	if($data['response']['numFound'] <= 0 && !$error){
		$error = __('По Вашему запросу ничего не найдено', true);
	}
	return $error;
}

function getStat($data){
	$time = getMicrotime() - $GLOBALS['TIME_START'];
	$out = '<br/><div id="numres"><small>';
	$out .= sprintf(__('Всего найдено: %s', true), $data['response']['numFound']);
	$out .= sprintf(__(' за %s сек.', true), sprintf("%3.2f ",$time));
	$out .= '</small></div><br/>';
	return $out;
}

function sortList($sort,$sortable,$page){
	list($sorted, $order) = explode('+',$sort);
	$names = array(
		'title'=>__('Заглавию', true),
		'author'=>__('Автору', true),
		'editors'=>__('Издательству', true),
		'years'=>__('Году', true),
	);
	$sort_menu[] = "<a href='javascript:changeOrder(\"\");'\">".__('Совпадению',true)."</a>";
	foreach ($sortable as $field){
		$symb = '';
		$dest = 'asc';
		$style= '';
		if($sorted == $field){
			$dest = ($order=='asc') ? 'desc' : 'asc';
			$symb = ($dest =='asc') ?  '&#9650;' : '&#9660;';
			$style = 'style="background-color:#EEF0F1"';
		}
		$field_sort = $field.'+'.$dest;
		$name = $names[$field].$symb;
		$sort_menu[] = "<a href=\"javascript:changeOrder('$field_sort');\" $style >".$name."</a>";
	}
	return '<div class="sortlist">'.__('Упорядочить по:', true).'  '.implode(' | ', $sort_menu).'</div>';
}

function getPaginate($sort,$pages,$page,$limit, &$javascript){
	$out = '';
	$ordered = '';
	
	if($pages > 1){
		if($pages > 100) $pages = 100;
		
		$out = "<div id='pagination'>";
		if($sort){
			$ordered = "var ordered = '".str_replace(' ','+',$sort)."';";
		}
		$out .=
		  $javascript->codeBlock("
			setPaginate = function(){
				jQuery('#pagination').paginate({
					count 		:  ". coalesce($pages,1) .",
					start 		:  ". coalesce($page,1) .",
					display     :  ". coalesce($limit,10) .",
					text_color  : '#3090F0',
					background_color  : 'none',	
					text_hover_color  : '#555555',
					background_hover_color	: 'none',
					onChange : changePage 
				});
			}
			$ordered
			setPaginate();
		  ");
		$out .= "</div>";
	}
	
	return $out;
}
?>