SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

/****** :  View [knigob].[DisciplinesList]     : 06/25/2009 15:19:44 ******/
CREATE VIEW [knigob].[DisciplinesList] AS 

SELECT     knigob.Links.Matiere, knigob.Links.Spec, knigob.Links.Spec1, KAF.Nom AS Kaf, knigob.Form.Valeur AS Form, knigob.Terms.Year, knigob.Terms.Term, 
                      MATIERE.Sujet, PROFESSION.Libelle, knigob.Links.Term AS IdTerm, knigob.Links.Kaf AS IdKaf, knigob.Links.IdForm
FROM         knigob.Links LEFT OUTER JOIN
                      PROFESSION ON knigob.Links.Spec = PROFESSION.IdProfession LEFT OUTER JOIN
                      MATIERE ON knigob.Links.Matiere = MATIERE.IdMatiere LEFT OUTER JOIN
                      knigob.Terms ON knigob.Links.Term = knigob.Terms.Id LEFT OUTER JOIN
                      knigob.Form ON knigob.Links.IdForm = knigob.Form.IdForm LEFT OUTER JOIN
                      KAF ON knigob.Links.Kaf = KAF.IdKaf
WHERE     (knigob.Links.Spec1 = 1)
UNION
SELECT     knigob.Links.Matiere, knigob.Links.Spec, knigob.Links.Spec1, KAF.Nom AS Kaf, knigob.Form.Valeur AS Form, knigob.Terms.Year, knigob.Terms.Term, 
                      MATIERE.Sujet, CATEG_SOCIO_PROF.libelle, knigob.Links.Term AS IdTerm, knigob.Links.Kaf AS IdKaf, knigob.Links.IdForm
FROM         knigob.Links LEFT OUTER JOIN
                      CATEG_SOCIO_PROF ON knigob.Links.Spec = CATEG_SOCIO_PROF.IdCategSocioProf LEFT OUTER JOIN
                      MATIERE ON knigob.Links.Matiere = MATIERE.IdMatiere LEFT OUTER JOIN
                      knigob.Terms ON knigob.Links.Term = knigob.Terms.Id LEFT OUTER JOIN
                      knigob.Form ON knigob.Links.IdForm = knigob.Form.IdForm LEFT OUTER JOIN
                      KAF ON knigob.Links.Kaf = KAF.IdKaf
WHERE     (knigob.Links.Spec1 = 0)
GO

/****** :  View [dbo].[knigob_matieres_books]     : 06/25/2009 15:18:58 ******/
CREATE VIEW [dbo].[knigob_matieres_books] AS
(
SELECT 
MATIERE.IdMatiere, 
MATIERE.Niveau, 
MATIERE.Sujet, 
MATIERE.IdThesaurus,
NOTICE_Z.IdNotice
FROM         MATIERE LEFT OUTER JOIN
NOTICE_Z ON MATIERE.IdMatiere = NOTICE_Z.Valeurn AND NOTICE_Z.IdZone = 'R600'
WHERE     (MATIERE.IdThesaurus = 4)
)
GO
/****** :  View [dbo].[knigob_matieres_students]     : 06/25/2009 15:16:35 ******/
CREATE VIEW [dbo].[knigob_matieres_students] AS 
(SELECT dl.Matiere AS IdMatiere, dl.IdTerm, sst.Year, sst.IdForm, sst.IdPayForm, sum(sst.StudCount) AS StudSum
FROM knigob.DisciplinesList dl
LEFT JOIN knigob.spec_students sst ON 
	sst.Spec1 = dl.Spec1 
	AND 
	sst.IdSpec = dl.Spec 
	AND 
	sst.Year = dl.Year 
	AND 
	sst.IdForm = dl.IdForm 
WHERE StudCount IS NOT NULL
GROUP BY dl.IdTerm, sst.Year, sst.IdForm, sst.IdPayForm, dl.Matiere
)

GO

/****** :  View [dbo].[knigob_books_students]     : 06/25/2009 15:13:54 ******/

CREATE VIEW [dbo].[knigob_books_students] AS (
SELECT     bm.IdNotice, count(DISTINCT(bm.IdMatiere)) as MatiereCount,
		   (IdTerm % 2) as odd, sum(ms.StudSum) as StudSum
FROM   dbo.knigob_matieres_books bm INNER JOIN
                      dbo.knigob_matieres_students ms ON bm.IdMatiere = ms.IdMatiere
GROUP BY bm.IdNotice, (IdTerm % 2)
)

GO

/****** :  View [dbo].[knigob_forms]     : 06/25/2009 15:15:00 ******/
CREATE VIEW [dbo].[knigob_forms]
AS
SELECT     IdForm, CAST(Valeur AS nvarchar(100)) AS Valeur
FROM         knigob.Form

GO

/****** :  View [dbo].[knigob_matieres]     : 06/25/2009 15:15:15 ******/
CREATE VIEW [dbo].[knigob_matieres]
AS
SELECT     IdMatiere, IdThesaurus, Niveau, CAST(Sujet AS nvarchar(255)) AS Sujet, CAST(VoirAussi AS nvarchar(255)) AS VoirAussi, CAST(Commentaire AS nvarchar) AS Commentaire, IdPere, IdRetenue, IdLotEchange, DateCreation, 
                      UserCreation, DateMaj, UserMaj
FROM         dbo.MATIERE

GO


/****** :  View [dbo].[knigob_notice_exemplaire]     : 06/25/2009 15:16:49 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[knigob_notice_exemplaire] AS 
SELECT IdNotice, count(IdExemplaire) AS ExempCount, Prix, sum(Prix) AS SumPrix FROM EXEMPLAIRE GROUP BY IdNotice, Prix
GO

CREATE VIEW [dbo].[knigob_view_books] 
AS (
SELECT NOTICE.IdNotice, NOTICE.Categ,   
				CASE
     				WHEN view_200fg.Valeur IS NOT NULL THEN view_200fg.Valeur
	 				ELSE v200g.Valeur END AS Auteur,
					v200a.Valeur AS Titre,  
					view_210c.Valeur AS Editeur, 
					CAST(dbo.fn_RIID_NOTICE_VALEUR(NOTICE.IdNotice, '210', 'd', 0) AS nvarchar(max)) AS Date,  
					v01x.Valeur AS ISBN,
					CAST(dbo.fn_RIID_COTE_NOTICE(NOTICE.IdNotice, 1) AS nvarchar(50)) AS Cote,  
					v856u.Valeur AS URL,
					ROW_NUMBER() OVER (ORDER BY Titre) AS RowNumber,
					---Exemplares---  
					_CATEG_NOTICE.Image, CAST(_CATEG_NOTICE.Libelle AS nvarchar(255)) AS Libelle 
					FROM NOTICE INNER JOIN _CATEG_NOTICE ON NOTICE.Categ = _CATEG_NOTICE.IdCategNotice AND (_CATEG_NOTICE.IdLangueSoft = 4)
					LEFT JOIN dbo.view_NOTICE_200a_100char v200a WITH (NOEXPAND) ON v200a.IdNotice = NOTICE.IdNotice 
					LEFT JOIN view_200fg WITH (NOEXPAND) ON view_200fg.IdNotice = NOTICE.IdNotice AND view_200fg.sZone = 'f'
					LEFT JOIN view_200fg v200g WITH (NOEXPAND) ON v200g.IdNotice = NOTICE.IdNotice AND v200g.sZone = 'g' AND v200g.NumOrdre = 0
					LEFT JOIN view_210c WITH (NOEXPAND) ON view_210c.IdNotice = NOTICE.IdNotice AND view_210c.NumOrdre = 0
					LEFT JOIN view_NOTICE_01x v01x WITH (NOEXPAND) ON v01x.IdNotice = NOTICE.IdNotice AND v01x.sZone = N'a' AND v01x.IdZone = N'010' AND (v01x.NumOrdre IS NULL OR v01x.NumOrdre = 0) 
					LEFT JOIN view_NOTICE_856u v856u WITH (NOEXPAND) ON v856u.IdNotice = NOTICE.IdNotice AND v856u.NumOrdre = 0
)
GO


/* UPDATE */
GO
/****** :  View [dbo].[knigob_matieres_books]     : 07/02/2009 13:53:12 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

/****** :  View [dbo].[knigob_matieres_books]     : 06/25/2009 15:18:58 ******/
ALTER VIEW [dbo].[knigob_matieres_books] AS
(
SELECT 
MATIERE.IdMatiere, 
MATIERE.Niveau, 
MATIERE.Sujet, 
MATIERE.IdThesaurus,
NOTICE_Z.IdNotice
FROM         MATIERE LEFT OUTER JOIN
NOTICE_Z ON MATIERE.IdMatiere = NOTICE_Z.Valeurn AND NOTICE_Z.IdZone = 'R600'
)
GO

/*   IdNotice (    ,   ) **/

ALTER VIEW [dbo].[knigob_books_students] AS (
SELECT     bm.IdNotice, count(DISTINCT(bm.IdMatiere)) as MatiereCount,
		   (IdTerm % 2) as odd, sum(ms.StudSum) as StudSum
FROM   dbo.knigob_matieres_books bm INNER JOIN
                      dbo.knigob_matieres_students ms ON bm.IdMatiere = ms.IdMatiere
WHERE bm.IdNotice IS NOT NULL
GROUP BY bm.IdNotice, (IdTerm % 2)
)
GO

/****** :  View [dbo].[knigob_professions_matieres]     : 07/03/2009 03:32:37 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE VIEW [dbo].[knigob_professions_matieres] AS
SELECT     PROFESSION.IdProfession, knigob.Terms.Id AS Term, knigob.Terms.Year, knigob.Links.Matiere AS IdMatiere, knigob_matieres.Sujet
FROM         knigob.Terms INNER JOIN
                      knigob.Links ON knigob.Terms.Id = knigob.Links.Term LEFT OUTER JOIN
                      knigob_matieres ON knigob.Links.Matiere = knigob_matieres.IdMatiere RIGHT OUTER JOIN
                      PROFESSION ON knigob.Links.Spec = PROFESSION.IdProfession
WHERE     (knigob.Links.Spec1 = 1)
GO
