<?php
class colorconverter
{
	var $name = 'colorconverter';
	
	/**
	 * Returns one of 20 shades
	 *
	 * @param int $colorStep
	 * @return string HTML color
	 */
	function changeColor($colorStep)
	{
		while ($colorStep > 20)	$colorStep -= 20;
		
		$colorHSB = array('h' => 0,'s' => 20,'b' => 100);
		$h = ceil((360/20)*$colorStep);
		$colorHSB['h'] = $h;
		
		$colorRGB = colorconverter::HSBtoRGB($colorHSB['h'], $colorHSB['s'], $colorHSB['b']);
		$colorHEX = colorconverter::RGBToHex($colorRGB['r'], $colorRGB['g'], $colorRGB['b']);
		
		return $colorHEX;
	}
	
	function RGBToHex($r, $g, $b) {
		//String padding bug found and the solution put forth by Pete Williams (http://snipplr.com/users/PeteW)
		$hex = "#";
		$hex.= str_pad(dechex($r), 2, "0", STR_PAD_LEFT);
		$hex.= str_pad(dechex($g), 2, "0", STR_PAD_LEFT);
		$hex.= str_pad(dechex($b), 2, "0", STR_PAD_LEFT);
 
		return $hex;
	}
	
	function HexToRGB($hex) {
		$hex = ereg_replace("#", "", $hex);
		$color = array();
 
		if(strlen($hex) == 3) {
			$color['r'] = hexdec(substr($hex, 0, 1) . $r);
			$color['g'] = hexdec(substr($hex, 1, 1) . $g);
			$color['b'] = hexdec(substr($hex, 2, 1) . $b);
		}
		else if(strlen($hex) == 6) {
			$color['r'] = hexdec(substr($hex, 0, 2));
			$color['g'] = hexdec(substr($hex, 2, 2));
			$color['b'] = hexdec(substr($hex, 4, 2));
		}
 
		return $color;
	}
	
	function RGBToHSB($r, $g, $b)
	{
		$b = max(max($r, $g), $b);
		$min = min(min($r, $g), $b);
		
		$s = ($b <= 0) ? 0 : round(1000*($b - $min)/$b);
		
		$b = round(($b/255)*100);
		$h = 0;
		if(($r==$g) && ($g==$b)) $h = 0;
		else if($r>=$g && $g>=$b) $h = 60*($g-$b)/($r-$b);
		else if($g>=$r && $r>=$b) $h = 60 + 60*($g-$r)/($g-$b);
		else if($g>=$b && $b>=$r) $h = 120 + 60*($b-$r)/($g-$r);
		else if($b>=$g && $g>=$r) $h = 180 + 60*($b-$g)/($b-$r);
		else if($b>=$r && $r>=$g) $h = 240 + 60*($r-$g)/($b-$g);
		else if($r>=$b && $b>=$g) $h = 300 + 60*($r-$b)/($r-$g);
		else $h = 0;
		$h = round($h);
		
		return array('h' => $h, 's' => $s, 'b' => $b);
	}
	
	function HSBtoRGB($h,$s,$v) {
		
		$h = round($h);
		$s = round($s*255/100);
		$v = round($v*255/100);
		
		if($s == 0) {
			$r = $g = $b = $v;
		} else {
		$t1 = $v;	
		$t2 = (255-$s)*$v/255;
		$t3 = ($t1-$t2)*($h%60)/60;
		if($h==360) $h = 0;
		if($h<60){$r=$t1; $b=$t2; $g=$t2+$t3;}
		else if($h<120) {$g=$t1; $b=$t2; $r=$t1-$t3;}
		else if($h<180) {$g=$t1; $r=$t2; $b=$t2+$t3;}
		else if($h<240) {$b=$t1; $r=$t2; $g=$t1-$t3;}
		else if($h<300) {$b=$t1; $g=$t2; $r=$t2+$t3;}
		else if($h<360) {$r=$t1; $g=$t2; $b=$t1-$t3;}
		else {$r=0;	$g=0; $b=0;}
		}
	return array('r' => $r, 'g' => $g, 'b' => $b);
	}
}
?>